# coding: utf-8

"""
    FilterLists Directory API

    An ASP.NET Core API serving the core FilterList information.

    The version of the OpenAPI document: v1
    Contact: b72d8917-851f-4864-ad5c-61630408048d@gb4emlsep.anonaddy.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class FilterListsDirectoryApplicationQueriesGetSoftwareResponse(BaseModel):
    """
    FilterListsDirectoryApplicationQueriesGetSoftwareResponse
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="The identifier.")
    name: Optional[StrictStr] = Field(default=None, description="The unique name.")
    description: Optional[StrictStr] = Field(default=None, description="The description.")
    home_url: Optional[StrictStr] = Field(default=None, description="The URL of the home page.", alias="homeUrl")
    download_url: Optional[StrictStr] = Field(default=None, description="The URL of the Software download.", alias="downloadUrl")
    supports_abp_url_scheme: Optional[StrictBool] = Field(default=None, description="If the Software supports the abp: URL scheme to click-to-subscribe to a FilterList.", alias="supportsAbpUrlScheme")
    syntax_ids: Optional[List[StrictInt]] = Field(default=None, description="The identifiers of the Syntaxes that this Software supports.", alias="syntaxIds")
    __properties: ClassVar[List[str]] = ["id", "name", "description", "homeUrl", "downloadUrl", "supportsAbpUrlScheme", "syntaxIds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FilterListsDirectoryApplicationQueriesGetSoftwareResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if home_url (nullable) is None
        # and model_fields_set contains the field
        if self.home_url is None and "home_url" in self.model_fields_set:
            _dict['homeUrl'] = None

        # set to None if download_url (nullable) is None
        # and model_fields_set contains the field
        if self.download_url is None and "download_url" in self.model_fields_set:
            _dict['downloadUrl'] = None

        # set to None if syntax_ids (nullable) is None
        # and model_fields_set contains the field
        if self.syntax_ids is None and "syntax_ids" in self.model_fields_set:
            _dict['syntaxIds'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FilterListsDirectoryApplicationQueriesGetSoftwareResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "homeUrl": obj.get("homeUrl"),
            "downloadUrl": obj.get("downloadUrl"),
            "supportsAbpUrlScheme": obj.get("supportsAbpUrlScheme"),
            "syntaxIds": obj.get("syntaxIds")
        })
        return _obj


